﻿var freq = [63, 125, 250, 500, 1000, 2000, 4000, 8000];
var freq_A = freq.concat(['A']);

function lg(x)
{
    return Math.log(x) / Math.log(10);
}

function deltaL(f, S, Omega)
{
    var c = 343;
    return 10 * lg(1 + (Omega * c * c / (f * f * S * 16 * Math.PI)));
}

function dB2dBA(L)
{
	var dA = [-26.2, -16.1, -8.6, -3.2, 0, +1.2, +1, -1.1];
	var x = 0;
	for(var i in dA)
	    if(L[i])
	        x += Math.pow(10, (L[i] + dA[i]) / 10);
    return 10 * lg(x);
}

function LwSpect(L0, av, bv)
{
    var spect = []
    for(var i = 0; i < 8; i++)
        if(av[i] != null)
            spect[i] = av[i] * lg(L0) + bv[i];
    spect[8] = dB2dBA(spect);
    return spect;
}

var lastL0 = 200;

function LwSpectP(L0, av, bv)
{
    lastL0 = L0;
    var sp = LwSpect(L0, av, bv);
    for(var f = 0; f < 9; f++)
        sp[f] = sp[f] ? (sp[f] < 10 ? '<10' : sp[f] > 100 ? '>100' : Math.round(sp[f])) : "-";
    return sp;
}

function getFloatArr(elem)
{
    var r = $(elem).val().match(/(\d+\.\d+|\d+)/g);
    return r ? r.slice(0) : [];
}
