﻿var sel_vr = [];

function adjust_num_list(sender)
{
    var v = sender.value.match(/(\d+\.\d+|\d+)/g);
    sender.value = v ? v.slice(0).join(', ') : '';
}

function l0_from_lwa(lwA, av, bv)
{
    var aA = av[4]; // 1kHz
    var bA = bv[4]; // 1kHz
    while(true)
    {
        var L0 = Math.pow(10, (lwA - bA) / aA);
        var lwA1 = LwSpect(L0, av, bv)[8];
        var delta = lwA1 - lwA;
        if(Math.abs(delta) < 0.25)
            return Math.round(L0);
        bA += delta;
    }
}

function set_L0_list()
{
    if( !confirm("Это действие полностью изменит таблицу Lw(L0), продолжить?") )
        return;
    var L0_list = $('#L0_list').val().match(/(\d+\.\d+|\d+)/g).slice(0);

    $('#Lw_table_body').empty();
    for(var j in L0_list)
        for(var i in sel_vr)
            appendLw(data2[sel_vr[i]], L0_list[j]);
}

function set_LwA_list()
{
    if( !confirm("Это действие полностью изменит таблицу Lw(L0), продолжить?") )
        return;
    var LwA_list = $('#LwA_list').val().match(/(\d+\.\d+|\d+)/g).slice(0);

    $('#Lw_table_body').empty();
    for(var j in LwA_list)
        for(var i in sel_vr)
        {
            var data = data2[sel_vr[i]];
            var L0 = l0_from_lwa(LwA_list[j], data.A, data.B);
            appendLw(data, L0);
        }
}

function selectLeaf(idx)
{
    $('#chars_panel').show();

    var aready_selected = false;
    for(var i in sel_vr)
        if(sel_vr[i] == idx)
        {
            aready_selected = true;
            break;
        }
    if(!aready_selected)
    {
        var li = $('#sel_vr_template').clone().removeAttr('id').show().insertBefore('#sel_vr_template');
        li.find('.name').html(data2[idx].names);
        li.find('.sel_vr_remover').click(function(e) {
            $(e.target).parents('li:first').remove();
            sel_vr = $.grep(sel_vr, function(el){ return el != idx });
            if(sel_vr.length==0)
            {
                $('#Lw_table_body').empty();
                $('#DI_table_body').empty();
                $('#DL_table_body').empty();
                $('#chars_panel').hide(1);
            }
            else
                $('tr.vr_idx_'+idx).remove();
        });

        sel_vr = sel_vr.concat( [idx] );

        appendLw(data2[idx],lastL0);
        appendDI(data2[idx]);
        appendDL(data2[idx]);
    }

    return false;
}

function appendLw(data,L0)
{
    var lw_row = $('#Lw_row_template tr').clone().appendTo('#Lw_table_body');
    lw_row.attr('class','vr_idx_'+data.idx)
    lw_row.find('.name').html(data.names);
    lw_row.find('.clone_row').click(function(e){
        var row = $(e.target).parents('tr:first');
        row.clone(true).insertAfter(row);
    });
    lw_row.find('.move_up_row').click(function(e){
        var row = $(e.target).parents('tr:first');
        row.prev('tr').insertAfter(row);
    });
    lw_row.find('.move_down_row').click(function(e){
        var row = $(e.target).parents('tr:first');
        row.next('tr').insertBefore(row);
    });
    lw_row.find('.delete_row').click(function(e){
        var row = $(e.target).parents('tr:first');
        var idx = lw_row.attr('class')
        if( $('#Lw_table_body tr[class$='+idx+']').length>1 )
            row.remove();
    });
    lw_row.find('input.L0_data').change(function(e) {
        var L0 = e.target.value;
        var row = $(e.target).parents('tr:first');
        var spect = LwSpectP(L0, data.A, data.B);
        row.find('td').each(function(i,el) { $(el).html(spect[i]); });
        row.find('input.LwA_data').val(spect[8]);
    }).val(L0).change();
    lw_row.find('input.LwA_data').change(function(e) {
        var LwA = e.target.value;
        var L0 = l0_from_lwa(LwA, data.A, data.B);
        $(e.target).parents('tr:first').find('input.L0_data').val(L0).change();
    });
}

function appendDI(data)
{
    if(data.DI_1 != undefined)
    {
        var di_1_row = $('#DI_rows_template tr.DI_1_DataRow').clone().appendTo('#DI_table_body');
        di_1_row.attr('class','vr_idx_'+data.idx);
        di_1_row.find(".name").html(data.names);
        di_1_row.find('td').each(function(i,el) { $(el).html(data.DI_1[i]) });
        if(data.DI_2 != undefined)
        {
            var di_2_row = $('#DI_rows_template tr.DI_2_DataRow').clone().appendTo('#DI_table_body');
            di_2_row.attr('class','vr_idx_'+data.idx);
            di_2_row.find(".name").html(data.names);
            di_2_row.find('.DI_2_Phi').html(data.DI_2_Phi);
            di_2_row.find('.DI_2_Theta').html(data.DI_2_Theta);
            di_2_row.find('td').each(function(i,el) { $(el).html(data.DI_2[i]) });
        }
    }
    $('#DIRECTION_INDEX').toggle($('#DI_table_body tr').length > 0);
}

function appendDL(data)
{
    if(data.DL != undefined)
    {
        var dl_row = $('#DL_row_template tr').clone().appendTo('#DL_table_body');
        dl_row.attr('class','vr_idx_'+data.idx);
        dl_row.find(".name").html(data.names);
        dl_row.find('.Omega_data').change(function(e) {
            var Omega = $(e.target).val();
            $(e.target).parents('tr:first').find('td').each(function(i,el) {
                $(el).html(Math.round(deltaL(freq[i], data.S, Omega) + data.DL[i]));
            });
        }).change();
    }
    $('#DELTA_L').toggle($('#DL_table_body tr').length > 0);
}

//*************************************************************************
var help_wnd;

function main()
{
    var tree = data2tree(data2);
    var tree_htm = tree2html(tree,0,
        function(key,value){return '<a href="#" class="leaf" onclick="return selectLeaf('+value+')">'+key
                                    +'&nbsp;<img src="r_arrow_12x12.bmp" alt="[->]"/></a>'}
        );
    $('#root').html(tree_htm).find('.branch').prepend('<img src="plus_12x12.bmp" alt="[+]"/>');

    $('a.help').click(function(){
        if( help_wnd && !help_wnd.closed )
        {
            //help_wnd.close(); вместо focus()
            help_wnd.open(this.href,'help_wnd');
            help_wnd.doSel();
            help_wnd.focus();
        }
        else
            help_wnd=window.open(this.href,'help_wnd');

        return false;
    }).attr('title','Справка');

    $('noscript').hide();
    $('#all_wrap').show();
}
$(document).ready(main);
