﻿function adjustNumList(that)
{
    var v = that.value.match(/(\d+\.\d+|\d+)/g);
    that.value = v ? v.slice(0).join(', ') : '';
}

function adjustDims(that)
{
    var D = that.value.match(/\D*(\d+\.\d+|\d+)\D+(\d+\.\d+|\d+)\D+(\d+\.\d+|\d+)\D*/);
    that.value = D ? D.slice(1,4).join('x') : '1x1x1';
}

function makeFilter(Omega, R, N, L0)
{
	var C = $('#roomCat').val();
	var iLpA = $('#iLpA').val();

	var SS = DirectSound(Omega, R);
	var RS = ReflectedSound(N);

	var correction = (  ($('#influx_vr_select_tab .vr_filter_count').val() > 0)
                     && ($('#exhaust_vr_select_tab .vr_filter_count').val() > 0)
                     ) ? 3 : 0; // -3дБ, поправка на приточные и выт.

	var max_Lw = new Array(9);
    for(var i in RS)
        max_Lw[i] = all_roomLp[iLpA][i] - 10 * lg(SS + RS[i]) - C - correction;
    max_Lw[8] = dB2dBA(max_Lw);

    return function(A, B)
    {
	    var spect = LwSpect(L0, A, B);
	    for(var i in spect.slice(0, 8))
	        if(spect[i] > max_Lw[i])
	            return false;
	    return spect[8] < max_Lw[8];
	}
}

function data2tree_ex(data)
{
    function add2tree(tree,keys,value)
    {
      if(typeof tree == "undefined")
         tree={};
      if(keys.length == 1)
         tree[keys[0]] = value
      else
         tree[keys[0]] = add2tree(tree[keys[0]], keys.slice(1), value);
      return tree;
    }
    var tree = {};
    for(var idx in data)
        add2tree(tree, data[idx].path, data[idx].uid);
    return tree;
}

function switch_to_room_param()
{
    $('.step_tab').hide();
    $('#room_param_tab').show();
    return false;
}

function switch_to_influx()
{
    $('.step_tab').hide();
    $('#influx_vr_select_tab').show();
    influx_update_tree();
    return false;
}

function switch_to_exhaust()
{
    $('.step_tab').hide();
    $('#exhaust_vr_select_tab').show();
    exhaust_update_tree();
    return false;
}

function switch_to_report()
{
    $('.step_tab').hide();
    $('#report_tab').show();

    $('#rep_roomSize').html($('#roomSize').val());
    $('#rep_roomType').html($('#roomType option:selected').html());
    $('#rep_roomCat').html($('#roomCat option:selected').html());
    $('#rep_lpmax_corr').toggle($('#roomCat').val() !=0);
    var iLpA = $('#iLpA').val();
    $('#rep_Lpmax_row td').each(function(i) { $(this).html(all_roomLp[iLpA][i]) });
    $('#rep_Lpmax_row th').html(all_roomLp[iLpA][4] + 5);

    report_chars($('#influx_vr_select_tab'),$('#report_influx'))
    report_chars($('#exhaust_vr_select_tab'),$('#report_exhaust'))

    $('#rep_vr_filter_influx_sheme').html($('#vr_filter_influx_sheme option:selected').html());

    return false;
}

function report_chars(bin,bout)
{
    var n = bin.find('.vr_filter_count').val();
    bout.toggle(n > 0);
    if(n == 0)
        return;
    bout.find('#rep_vrCount').html(n);
    bout.find('#rep_vrOmega,#rep_tbl_Omega').html(bin.find('.vr_filter_omega option:selected').html());
    bout.find('#rep_vrR_list_block').toggle(bin.find('.vr_filter_R_list').val() != '');
    bout.find('#rep_vrR_list').html(bin.find('.vr_filter_R_list').val());

    var L0 = bin.find('.vr_filter_L0max').val();
    bout.find('#rep_L0max, #rep_tbl_L0').html(L0);

    bout.find('#rep_Lw_table_body').empty();
    bout.find('#rep_DI_table_body').empty();
    bout.find('#rep_DL_table_body').empty();
    var list = bin.find('.sel_vr_list li:not(.sel_vr_template)').each(function() {
        var idx = $(this).attr('id').match(/sel_vr_(\d+)/)[1];

        var lw_row = bout.find('#rep_Lw_row_template tr').clone().appendTo(bout.find('#rep_Lw_table_body'));
        lw_row.find('.name').html(data2[idx].names);
        var spect = LwSpectP(L0, data2[idx].A, data2[idx].B);
        lw_row.find('td').each(function(i,el) { $(el).html(spect[i]); });

        if(data2[idx].DI_1 != undefined)
        {
            var di_1_row = bout.find('#rep_DI_rows_template tr.DI_1_DataRow').clone().appendTo(bout.find('#rep_DI_table_body'));
            di_1_row.find('.name').html(data2[idx].names);
            di_1_row.find('td').each(function(i,el) { $(el).html(data2[idx].DI_1[i]) });
            if(data2[idx].DI_2 != undefined)
            {
                var di_2_row = bout.find('#rep_DI_rows_template tr.DI_2_DataRow').clone().appendTo('#rep_DI_table_body');
                di_2_row.find(".name").html(data2[idx].names);
                di_2_row.find('.DI_2_Phi').html(data2[idx].DI_2_Phi);
                di_2_row.find('.DI_2_Theta').html(data2[idx].DI_2_Theta);
                di_2_row.find('td').each(function(i,el) { $(el).html(data2[idx].DI_2[i]) });
            }
        }
        if(data2[idx].DL != undefined)
        {
            var Omega = bin.find('.vr_filter_omega').val();
            var dl_row = bout.find('#rep_DL_row_template tr').clone().appendTo(bout.find('#rep_DL_table_body'));
            dl_row.find('.name').html(data2[idx].names);
            dl_row.find('td').each(function(i,el) { $(el).html(Math.round(deltaL(freq[i],data2[idx].S,Omega) + data2[idx].DL[i])); });
        }
    });
    bout.toggle(list.length > 0);
    bout.find('#DIRECTION_INDEX').toggle(bout.find('#rep_DI_table_body tr').length > 0);
    bout.find('#DELTA_L').toggle(bout.find('#rep_DL_table_body tr').length > 0);
}

function influx_update_tree()
{
    var sheme_mask = $('#vr_filter_influx_sheme').val();
    common_update_tree($('#influx_vr_select_tab'), function (filter) {
        var data = $.grep(data2, function (data) { return (data.SHEMA & sheme_mask) && filter(data.A, data.B); });
        return data2tree_ex(data);
    })
}

function exhaust_update_tree()
{
    common_update_tree($('#exhaust_vr_select_tab'), function (filter) {
        var data = $.grep(data2, function (data) { return (data.SHEMA & 1024) && filter(data.A, data.B); });
        return data2tree_ex(data);
    })
}

function common_update_tree(tab,tree_generator)
{
    tab.find('.root').html("<i>Ждите окончания подбора...</i>");

    var tree_htm =  '--';
    var n = tab.find('.vr_filter_count').val();
    if(n > 0)
    {
        var filter = makeFilter(
            tab.find('.vr_filter_omega').val()
            , getFloatArr(tab.find('.vr_filter_R_list'))
            , n
            , tab.find('.vr_filter_L0max').val()
            )
        var tree = tree_generator(filter);
        var i=0;for(var j in tree)i++;
        if( i>0 )
            tree_htm = tree2html(tree,0,function(name,id){
                return  '<a href="#" class="leaf" onclick="return selectLeaf(this,'+id+')">' + name
                        + '&nbsp;<img src="r_arrow_12x12.bmp" alt="[->]"/></a>';
            });
    }
    tab.find('.root').html(tree_htm);

    tab.find('.root .branch').prepend('<img src="plus_12x12.bmp" alt="[+]"/>');
}

function selectLeaf(sender,idx)
{
    var tab = $(sender).parents('.step_tab:first');

    tab.find('.sel_vr_empty').hide();

    if(tab.find('#sel_vr_'+idx).length == 0)
    {
        var tmpl = tab.find('.sel_vr_template');
        tmpl.clone().removeClass('sel_vr_template').attr('id','sel_vr_'+idx).show().insertBefore(tmpl).find('.name').html(data2[idx].names);
    }

    return false;
}

function remove_sel_vr(sender)
{
	var tab = $(sender).parents('.step_tab:first');

	$(sender).parents('li:first').remove();

	var n = tab.find('.sel_vr_list li:visible').length;
	tab.find('.sel_vr_empty').toggle(n == 0);
}

function main()
{
    for(var uid in data2)
        data2[uid]['uid'] = uid;

    $('a.help').click(function() {
        if(help_wnd && !help_wnd.closed)
        {
            //help_wnd.close(); вместо focus()
            help_wnd.open(this.href, 'help_wnd');
            help_wnd.doSel();
            help_wnd.focus();
        }
        else
            help_wnd=window.open(this.href, 'help_wnd');

        return false;
    }).attr('title', 'Справка');

    $('noscript').hide();

    $('#exhaust_vr_select_tab .vr_params').find('input, select').change(exhaust_update_tree);
    $('#influx_vr_select_tab .vr_params').find('input, select').change(influx_update_tree);

    setLp();
    switch_to_room_param();
}
$(document).ready(main);

//=========================================================================================================

function DirectSound(Omega,R)
{
	var SS=0;
	for(var i in R)
	    SS += 1 / (R[i]*R[i]);
	return SS / (Omega * Math.PI);
}

function ReflectedSound(count)
{
	var D = $('#roomSize').val().match(/\D*(\d+\.\d+|\d+)\D+(\d+\.\d+|\d+)\D+(\d+\.\d+|\d+)\D*/);
	D = D ? D.slice(1,4) : [1,1,1];
	var roomV = D[0] * D[1] * D[2];
	var roomS = (D[0] * D[1] + D[0] * D[2] + D[1] * D[2]) * 2;

	var all_mu=
	[   [0.8, 0.75, 0.7, 0.8, 1, 1.4, 1.8, 2.5]
	,   [0.65, 0.62, 0.64, 0.75, 1, 1.5, 2.4, 4.2]
	,   [0.5, 0.5, 0.55, 0.7, 1, 1.6, 3, 6]
	];
	var mu = all_mu[roomV < 200 ? 0 : roomV < 1000 ? 1 : 2];

	var roomB1000 = roomV / $('#roomType').val();

	function Phi_BS(x) { return 0.1524 * x * x - 0.5967 * x + 0.9504; }

	var RS = new Array(8);
	for(var i = 0; i < 8; i++)
		RS[i] = count * 4 * Phi_BS(roomB1000 * mu[i] / roomS) / (roomB1000 * mu[i]);
	return RS;
}

var all_roomLp=
[	[51, 39, 31, 24, 20, 17, 14, 13]
,	[55, 44, 35, 29, 25, 22, 20, 18]
,	[59, 48, 40, 34, 30, 27, 25, 23]
,	[63, 52, 45, 39, 35, 32, 30, 28]
,	[67, 57, 49, 44, 40, 37, 35, 33]
,	[71, 61, 54, 49, 45, 42, 40, 38]
,	[75, 66, 59, 54, 50, 47, 45, 44]
,	[79, 70, 68, 58, 55, 52, 52, 49]
,	[83, 74, 68, 63, 60, 57, 55, 54]
,	[87, 79, 72, 68, 65, 63, 61, 59]
,	[91, 83, 77, 73, 70, 68, 66, 64]
,	[95, 87, 82, 78, 75, 73, 71, 69]
];

function setLp()
{
	var iLpA=$('#iLpA').val();
	$('#roomLp_view_row td').each(function(i) { $(this).html(all_roomLp[iLpA][i]) });
}
